<?php
/*
Plugin Name: HTTP Iframe in HTTPS
Description: It adds a shortcode to embed a HTTP iframe in your HTTPS website without having problems with mixed content errors
Author: Jose Mortellaro
Author URI: https://josemortellaro.com/
Version: 0.0.1
*/
/*  This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
if ( isset( $_GET['proxy'] ) && isset( $_GET['url'] ) && md5( esc_attr( $_GET['url'] ) ) === $_GET['proxy'] ){
	$response = wp_remote_get( esc_url( $_GET['url'] ) );
	if( $response ){
		echo wp_remote_retrieve_body( $response );
	}
	exit;
}
add_shortcode( 'eos_http_iframe','eos_http_iframe' );
function eos_http_iframe( $atts ){
	$atts = shortcode_atts( array(
		'url' => '',
		'class' => '',
		'width' => '100%'
	),$atts,'eos_http_iframe' );
	if( '' === $atts['url'] ) return;
	$class = '' !== $atts['class'] ? ' '.$class : '';
	return '<iframe style="width:'.esc_attr( $atts['width'] ).'" class="eos-http-iframe'.esc_attr( $class ).'" src="?proxy='.md5( esc_attr( $atts['url'] ) ).'&url='.esc_url( $atts['url'] ).'"></iframe>';
}	